## org.mortbay.jetty.client
Class ContentExchange

    java.lang.Object
      org.mortbay.jetty.client.HttpExchange
          org.mortbay.jetty.client.CachedExchange
              org.mortbay.jetty.client.ContentExchange

Direct Known Subclasses:
  BayeuxClient.Exchange, HttpExchange.ContentExchange

    public class ContentExchange

extends CachedExchange

A CachedExchange that retains response content for later use.

Nested Class Summary

Nested classes/interfaces inherited from class org.mortbay.jetty.client.HttpExchange
`HttpExchange.CachedExchange, HttpExchange.ContentExchange`

Field Summary
`protected int` `_contentLength`
`protected String` `_encoding`
`protected File` `_fileForUpload`
`protected ByteArrayOutputStream2` `_responseContent`
`protected int` `_responseStatus`

Fields inherited from class org.mortbay.jetty.client.CachedExchange
`_responseFields`

Fields inherited from class org.mortbay.jetty.client.HttpExchange
`STATUS_COMPLETED, STATUS_EXCEPTED, STATUS_EXPIRED, STATUS_PARSING_CONTENT, STATUS_PARSING_HEADERS, STATUS_SENDING_REQUEST, STATUS_START, STATUS_WAITING_FOR_COMMIT, STATUS_WAITING_FOR_CONNECTION, STATUS_WAITING_FOR_RESPONSE`

Constructor Summary
`ContentExchange()`
`ContentExchange(boolean keepHeaders)`

Method Summary
`File` `getFileForUpload()`
`byte[]` `getResponseBytes()`
`String` `getResponseContent()`
`int` `getResponseStatus()`
`protected void` `onResponseContent(Buffer content)` Called for each chunk of the response content received.
`protected void` `onResponseHeader(Buffer name, Buffer value)` Called for each response header received
`protected void` `onResponseStatus(Buffer version, int status, Buffer reason)` Called when a response status line has been received.
`protected void` `onRetry()` Called when the request is retried (due to failures or authentication).
`void` `setFileForUpload(File fileForUpload)`
`void` `writeResponseBytesTo(OutputStream out)`

Methods inherited from class org.mortbay.jetty.client.CachedExchange
`getResponseFields`

Methods inherited from class org.mortbay.jetty.client.HttpExchange

`addRequestHeader, addRequestHeader, cancel, configureListeners, getAddress, getEventListener, getMethod, getRequestContent, getRequestContentChunk, getRequestContentSource, getRequestFields, getRetryStatus, getScheme, getStatus, getURI, getVersion, isDone, onConnectionFailed, onException, onExpire, onRequestCommitted, onRequestComplete, onResponseComplete, onResponseHeaderComplete, reset, setAddress, setConfigureListeners, setEventListener, setMethod, setRequestContent, setRequestContentSource, setRequestContentType, setRequestHeader, setRequestHeader, setRetryStatus, setScheme, setURI, setURL, setVersion, setVersion, toString, waitForDone, waitForStatus`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### _responseStatus

    protected int _responseStatus

### _contentLength

    protected int _contentLength

### _encoding

    protected String _encoding

### _responseContent

    protected ByteArrayOutputStream2 _responseContent

### _fileForUpload

    protected File _fileForUpload

Constructor Detail

### ContentExchange

    public ContentExchange()

### ContentExchange

    public ContentExchange(boolean keepHeaders)

Method Detail

### getResponseStatus

    public int getResponseStatus()

  Overrides:
    `getResponseStatus` in class `CachedExchange`

### getResponseContent

    public String getResponseContent()
                              throws UnsupportedEncodingException

  Returns:
    The response content as a String
  Throws:
    `UnsupportedEncodingException`

### getResponseBytes

    public byte[] getResponseBytes()

  Returns:
    The response content as a byte array;

### writeResponseBytesTo

    public void writeResponseBytesTo(OutputStream out)
                              throws IOException

  Parameters:
    `out` - An output stream to write the content to.
  Throws:
    `IOException`

### onResponseStatus

    protected void onResponseStatus(Buffer version,
                                    int status,
                                    Buffer reason)
                             throws IOException

  Description copied from class: `HttpExchange`
  Called when a response status line has been received.

  Overrides:
    `onResponseStatus` in class `CachedExchange`
  Parameters:
    `version` - HTTP version
    `status` - HTTP status code
    `reason` - HTTP status code reason string
  Throws:
    `IOException`

### onResponseHeader

    protected void onResponseHeader(Buffer name,
                                    Buffer value)
                             throws IOException

  Description copied from class: `HttpExchange`
  Called for each response header received

  Overrides:
    `onResponseHeader` in class `CachedExchange`
  Parameters:
    `name` - header name
    `value` - header value
  Throws:
    `IOException`

### onResponseContent

    protected void onResponseContent(Buffer content)
                              throws IOException

  Description copied from class: `HttpExchange`
  Called for each chunk of the response content received.

  Overrides:
    `onResponseContent` in class `HttpExchange`
  Throws:
    `IOException`

### onRetry

    protected void onRetry()
                    throws IOException

  Description copied from class: `HttpExchange`
  Called when the request is retried (due to failures or authentication). Implementations may need to reset any consumable content that needs to be sent.

  Overrides:
    `onRetry` in class `HttpExchange`
  Throws:
    `IOException`

### getFileForUpload

    public File getFileForUpload()

### setFileForUpload

    public void setFileForUpload(File fileForUpload)
                          throws IOException

  Throws:
    `IOException`

Copyright © 1995-2010 Mort Bay Consulting. All Rights Reserved.